﻿#light

// Integer value (int)
let n = 42

// String value (string)
let str = "Hello world!"

// Function (int -> int)
let add10(n) = n + 10

// Function - generic - returns parameter ('a -> 'a)
let id(o) = o

// Function with function as a parameter
// (int -> 'a) -> 'a
let call42(f) = 
  f 42

// Can't resolve overload in the following case
//let printInt_E(n) = 
//  System.Console.WriteLine(n);

// Explicitly declared type using type annotation
let printInt( (n:int) ) = 
  System.Console.WriteLine("Print int: {0}", n);
 
// Passing function as a parameter
call42(printInt)

// Passing anonymous function as a parameter
let result = call42( fun n -> n * 2 )
System.Console.WriteLine(result)